=== gnuradio-runtime/examples/CMakeLists.txt ===
# Copyright 2011 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

add_subdirectory(mp-sched)
add_subdirectory(network)
add_subdirectory(volk_benchmark)
