=== debian/changelog ===
gnuradio (3.9.4.0-3build1) jammy; urgency=medium

  * No-change rebuild with Python 3.10 as default version

 -- Graham Inggs <ginggs@ubuntu.com>  Sat, 15 Jan 2022 08:35:44 +0000

gnuradio (3.9.4.0-3) unstable; urgency=medium

  * update to v3.9.4.0-22-g2cdde7b89
  * use realistic build-depends architectures (Closes: #1000792)

 -- A. Maitland Bottoms <bottoms@debian.org>  Tue, 07 Dec 2021 22:11:30 -0500

gnuradio (3.9.4.0-2) unstable; urgency=medium

  * update to v3.9.4.0-17-g981d5834a

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 27 Nov 2021 12:02:04 -0500

gnuradio (3.9.4.0-1) experimental; urgency=medium

  * New upstream release

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 31 Oct 2021 12:20:07 -0400

gnuradio (3.9.2.0-2) experimental; urgency=medium

  * Add Breaks+Replaces for gr-soapy (Closes: #989888)

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 19 Jun 2021 10:05:57 -0400

gnuradio (3.9.2.0-1) experimental; urgency=medium

  * New upstream release

 -- A. Maitland Bottoms <bottoms@debian.org>  Thu, 10 Jun 2021 19:51:53 -0400

gnuradio (3.9.0.0-2) experimental; urgency=medium

  * bump CMAKE_CXX_STANDARD 17

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 18 Jan 2021 10:48:04 -0500

gnuradio (3.9.0.0-1) experimental; urgency=medium

  * New upstream release

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 17 Jan 2021 19:30:58 -0500

gnuradio (3.9.0.0~rc2-1) experimental; urgency=medium

  * New upstream release candidate

 -- A. Maitland Bottoms <bottoms@debian.org>  Thu, 07 Jan 2021 16:22:20 -0500

gnuradio (3.9~rc0-1) experimental; urgency=medium

  * v3.8.0.0-845-g592dfc78a aka 3.9.0.RC0 from new maint-3.9 branch
    pybind11 branch merged onto master
    Headed toward a 3.9 release.

 -- A. Maitland Bottoms <bottoms@debian.org>  Wed, 23 Dec 2020 12:40:17 -0500

gnuradio (3.8.1.0~pybind-1) unstable; urgency=medium

  * New upstream branch

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 30 May 2020 19:46:02 -0400
