=== debian/watch ===
version=4
 opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%,uversionmangle=s/-rc/~rc/,compression=xz,repack" \
 https://github.com/gnuradio/gnuradio/releases/ \
 (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate \
